library benchmarks.src.element_injector.element_injector_benchmark;

import "package:angular2/src/core/reflection/reflection.dart" show reflector;
import "package:angular2/src/core/reflection/reflection_capabilities.dart"
    show ReflectionCapabilities;
import "package:angular2/core.dart" show Injectable, Injector;
import "package:angular2/src/core/linker/element_injector.dart"
    show ProtoElementInjector, DirectiveProvider;
import "package:angular2/src/testing/benchmark_util.dart"
    show getIntParameter, bindAction, microBenchmark;
import "package:angular2/src/core/dom/browser_adapter.dart"
    show BrowserDomAdapter;

var count = 0;
main() {
  BrowserDomAdapter.makeCurrent();
  var iterations = getIntParameter("iterations");
  reflector.reflectionCapabilities = new ReflectionCapabilities();
  var providers = [
    DirectiveProvider.createFromType(A, null),
    DirectiveProvider.createFromType(B, null),
    DirectiveProvider.createFromType(C, null)
  ];
  var proto = ProtoElementInjector.create(null, 0, providers, false, 0, null);
  var elementInjector = proto.instantiate(null);
  instantiate() {
    for (var i = 0; i < iterations; ++i) {
      var ei = proto.instantiate(null);
      ei.hydrate(null, null, null);
    }
  }
  hydrate() {
    for (var i = 0; i < iterations; ++i) {
      elementInjector.dehydrate();
      elementInjector.hydrate(null, null, null);
    }
  }
  bindAction("#instantiate",
      () => microBenchmark("instantiateAvg", iterations, instantiate));
  bindAction(
      "#hydrate", () => microBenchmark("instantiateAvg", iterations, hydrate));
}

@Injectable()
class A {
  A() {
    count++;
  }
}

@Injectable()
class B {
  B() {
    count++;
  }
}

@Injectable()
class C {
  C(A a, B b) {
    count++;
  }
}
